#!/usr/local/bin/perl
##############################################
# MeySoft Banner Manager - Version 2.5F
# Configuration Utility
# Created May 12, 1998
# Copyright (c) 1997 MeySoft
# Author: Jeffrey L. Meyer, Sr.Programmer
# CGI@MeySoft.com
###############################################
# THIS HEADER MUST REMAIN INTACT
#

require "config25.pl";

if($ENV{'REQUEST_METHOD'} eq 'POST'){
   read(STDIN,$data,$ENV{'CONTENT_LENGTH'});
 }else{
   $data="$ENV{'QUERY_STRING'}";
 }
@fields = split(/&/,$data);
foreach $fields(@fields){
  ($field_name,$field_val)=split(/=/,$fields);
  $field_val=~ tr/+/ /;
  $field_val=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
 $DATA{$field_name}=$field_val;
}

$password="$DATA{'password'}";


$cfg_file="config25";

print "Content-type: text/html\n\n";
print "<HTML><HEAD><TITLE>Configuration Results</TITLE></HEAD><BODY BGCOLOR=FFFFFF>";

if(&check_pw == 0){
 print "Invalid password \'$DATA{'password'}\'...</body></html>";
 exit 0;
}

#############
# Make backup
print "<h3>Old <I>config25.pl</I> backed up as <I>config25.bak</I></h3>";

open(OLD,"<config25.pl") or &send_error("$!");
open(BAK,">config25.bak") or &send_error("$!");
while($line=<OLD>){
 print BAK "$line";
}
close(BAK);
close(OLD);
`chmod 755 config25.bak`;

if($ENV{'REQUEST_METHOD'} eq 'POST'){
   read(STDIN,$data,$ENV{'CONTENT_LENGTH'});
 }else{
   $data="$ENV{'QUERY_STRING'}";
 }
@fields = split(/&/,$data);
foreach $fields(@fields){
  ($field_name,$field_val)=split(/=/,$fields);
  $field_val=~ tr/+/ /;
  $field_val=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
 $DATA{$field_name}=$field_val;
}

print "Creating new config file ( config25.new )...";

open(NEW,">$cfg_file.new") or &send_error("$!");
print NEW <<"HEAD";
##############################################################
# MeySoft Banner Manager 2.5F Configuration File for PERL 4/5
# \$Id: config25.pl,v 2.5A 1998/05/15  MeySoft Exp \$
# Copyright (c) 1998 MeySoft
# AUTHOR: Jeffrey L. Meyer
# webmaster\@meysoft.com
# Last Update May 15, 1998
#
# THIS HEADER MUST REMAIN INTACT. YOU ARE LICENSED
# TO USE THIS ON A SINGLE SERVER ONLY.
# FURTHER, ALL COPYRIGHT NOTICES 
# MUST REMAIN INTACT IN ALL SCRIPTS.
#
################################################################
# ALL NECESSARY MODIFICATIONS ARE BELOW THIS LINE
# MAKE CHANGES ONLY ON THE RIGHT SIDE OF = SYMBOL

# PLEASE REFER TO THE ONLINE MANUAL
# FOR SETTING THESE VALUES
# You are encouraged to use the Admin Editor to make these
# changes.

\$site_address=\"$site_address\"\;
HEAD

foreach $fldname(sort keys %DATA){
if($fldname =~ /COL/){
  $line="\$COLOR\{\'";
$value="$DATA{$fldname}";
 $fldname=~ s/COL_//g;
}else{
   $line=" \$CFG\{\'";
$value="$DATA{$fldname}";
}
   $line .= "$fldname\'\}=\"";

   $line .= "$value\"\;";
print NEW "$line\n";
}


print NEW <<"FOOT";
###############
sub send_header\{
  local(\$title)=\@_;
  print \"Content-type: text/html\\n\\n\";
  print <<\"PAGE\";
<HTML>
<HEAD>
<TITLE>\$title</TITLE>
</HEAD>
<BODY BGCOLOR=\\\"#\$COLOR\{'bgcolor'\}\\\" text=\\\"#\$COLOR\{'text'\}\\\" link=\\\"#\$COLOR\{'link'\}\\\" alink=\\\"#\$COLOR\{'alink'\}\\\" vlink=\\\"#\$COLOR\{'vlink'\}\\\"
PAGE
if(\"\$COLOR\{'background'\}\" ne \"\")\{ 
  print \" background=\\\"\$COLOR\{'background'\}\\\"\"\;
\}
print \">\\n\"\;

if(!(-e \"htmlhead.html\"))\{
 open(NEW,\">htmlhead.html\")\;
 print NEW \"<!-- HTML HEAD -->\"\;
 close(NEW)\;
 \`chmod \$CFG\{\'file_permissions\'\} htmlhead.html\`\;
\}
open(HTML,\"<htmlhead.html\") or die \"\$\!\"\;
while(\$line=<HTML>)\{
 print \"\$line\"\;
\}
close(HTML)\;

\}
####################################
sub send_footer\{
if(!(-e \"htmlfoot.html\"))\{
 open(NEW,\">htmlfoot.html\")\;
 print NEW \"<!-- HTML FOOT -->\"\;
 close(NEW)\;
 \`chmod \$CFG\{\'file_permissions\'\} htmlfoot.html\`\;
\}
open(HTML,\"<htmlfoot.html\") or die \"\$\!\"\;
while(\$line=<HTML>)\{
 print \"\$line\"\;
\}
close(HTML)\;

 print \"</BODY></HTML>\\n\\n\"\;
\}
###############################
# END OF REQUIRED MODIFICATIONS
#
# DO NOT EDIT BELOW THIS LINE
#############################################
\$CFG\'version=\"2.5F \$site_address MS10000001V25F\"\;
#############################################
1\;
FOOT
close(NEW);
`chmod 755 $cfg_file.new`;

print "Done.<BR>";

print "<BR><B>Here is the new file. Carefully review it and make sure it appears ok, then click the commit link to save as the new config25.pl file</B><BR><BR>";

print "<XMP>";

open(FILE,"<config25.new") or &send_error("$!");
while($line=<FILE>){
 print "$line";
}
close(FILE);
print "</XMP><a href=\"commit.cgi\">COMMIT</a><BR><BR>";
exit 0;
############
sub check_pw{
open(PW,"<pw.dat") or die"$!";
$pass=<PW>;
close(PW);
 $test_pw=crypt($password,substr($CFG{'encrypt_key'},0,2));
 if(!($test_pw eq $pass)){
 $pok=0;
}else{
 $pok=1;
}
return $pok;
}

sub send_error{
 local($msg)=@_;
  print "Error: $msg<BR>";
  print "</body></html>";
exit 0;
}